<template>
    <div :id="`quick-select-${ table }`">
        <input @keyup="updateMatches" @focus="showOptions" @blur="hideOptions" class="form-control" type="text"
               :id="`quick-select-${ table }-input`" placeholder="Write here" autocomplete="off"
        >
        <list v-if="focus" :matches="matches" :table="table" :link="false" @select:match="select"/>
    </div>
</template>

<script>
    import List from "@/components/List";

    export default {
        name: "quick-select",
        components: {
            List
        },
        props: {
            table: {
                type: String,
                required: true
            }
        },
        data() {
            return {
                matches: [],
                focus: false,
            }
        },
        computed: {
            inputName() {
                if (this.isEntertainment) {
                    return 'title'
                } else if (this.isPeople) {
                    return 'person'
                } else {
                    return null
                }
            },
        },
        methods: {
            async updateMatches() {
                try {
                    const text = document.getElementById(`quick-select-${this.table}-input`).value.trim();
                    if (text) {
                        let response = await fetch(`http://localhost:8081/api/${this.table}?like=${text}`);
                        let data = await response.json();
                        let ids = [];
                        for (let match of data) {
                            ids.push(match.id);
                        }
                        this.matches = data;
                        /*response = await fetch(`http://localhost:8081/api/${this.table}?like=%${text}%`);
                        data = await response.json();
                        for (let match of data) {
                            if (ids.indexOf(match.id) === -1) {
                                this.matches = [...this.matches, match];
                            }
                        }*/
                    } else {
                        this.matches = [];
                    }
                } catch (e) {
                    console.log(e)
                }
            },
            clear() {
                document.getElementById(`quick-select-${ this.table }-input`).value = '';
                this.matches = [];
            },
            select(option) {
                this.$emit('select:option', option);
            },
            differentiate(option) {
                if (this.isPeople) {
                    return option.known_for ? `(${option.job}, ${option.title})` : ''
                } else if (this.isEntertainment) {
                    return `(${option.released}${option.ended ? `-${option.ended}` : ''} ${option.type})`
                }
            },
            hideOptions() {
                this.focus = false;
            },
            async showOptions() {
                this.focus = true;
            },
        }
    };
</script>

<style scoped>
    ul a {
        text-decoration: none;
        color: black;
    }

    ul a:hover {
        color: darkgrey;
    }

    ul a:active {
        color: dimgrey;
    }

    ul {
        position: absolute;
    }

    ul li {
        cursor: pointer;
    }
</style>